--------------------------------------------------------------------------------
-- Taser by holzchopf
--------------------------------------------------------------------------------

-- setup
if holzchopf==nil then holzchopf={} end
holzchopf.taser={}
holzchopf.taser.target=0
holzchopf.taser.tx=0
holzchopf.taser.ty=0

-- load ressources
holzchopf.taser.gfx_wpn=loadgfx("holzchopf/taser.bmp")
setmidhandle(holzchopf.taser.gfx_wpn)
holzchopf.taser.sfx_tase=loadsfx("holzchopf/tase.ogg")

--------------------------------------------------------------------------------
-- Weapon
--------------------------------------------------------------------------------
holzchopf.taser.id=addweapon("holzchopf.taser","Taser",holzchopf.taser.gfx_wpn,1,2)

function holzchopf.taser.draw()
	setblend(blend_alpha)
	setalpha(1)
	setcolor(255,233,110)
	drawinhand(holzchopf.taser.gfx_wpn,6,0)
	-- HUD Crosshair
	if weapon_shots==0 then
		hudcrosshair(6,3)
	end
end

function holzchopf.taser.attack(attack)
	-- attack
	if (weapon_shots<=0) and (attack==1) then
		-- no more weapon switching!
		useweapon(0)
		recoil(3)
		playsound(holzchopf.taser.sfx_tase)
		weapon_shots=weapon_shots+1
		weapon_timer=getframe()
		weapon_mode=1
		-- look for target
		local a=math.rad(getplayerrotation(0))
		local x=getplayerx(0)+6*getplayerdirection(0)+math.sin(a-0.294*getplayerdirection(0))*7
		local y=getplayery(0)+3-math.cos(a-0.294*getplayerdirection(0))*7
		for r=0,150,2 do
			local nx=x+math.sin(a)*r-1
			local ny=y-math.cos(a)*r-1
			-- hit player
			if collision(col2x2,nx,ny,1,1,0,playercurrent())==1 then
				if playercollision()~=0 then
					holzchopf.taser.target=playercollision()
					holzchopf.taser.tx=nx+1
					holzchopf.taser.ty=ny+1
					break
				elseif terraincollision()~=0 then
					holzchopf.taser.target=-1
					holzchopf.taser.tx=nx+1
					holzchopf.taser.ty=ny+1
					break
				end
			end
		end
	end
	-- electrify
	if weapon_shots>0 and weapon_mode==1 then
		local t=getframe()-weapon_timer
		if t>=50 then
			holzchopf.taser.target=0
			weapon_mode=0
			endturn()
		end
		-- electrify target
		if holzchopf.taser.target~=0 then
			if holzchopf.taser.target>0 and (t%10)==0 then
				playerdamage(holzchopf.taser.target,10)
			end
			local a=math.rad(getplayerrotation(0)-17*getplayerdirection(0))
			local x=getplayerx(0)+6*getplayerdirection(0)+math.sin(a)*7
			local y=getplayery(0)+3-math.cos(a)*7
			local dx=holzchopf.taser.tx-x
			local dy=holzchopf.taser.ty-y
			local dist=math.sqrt(dx*dx+dy*dy)
			local ex=dx/dist
			local ey=dy/dist
			-- fx
			for r=0,dist,2 do
				local a=math.sin(math.pi*6*r/dist)*math.sin(0.31*r)*math.sin(0.13*r+t*0.01)*math.sin(0.07*r)*t/5
				if t<49 then
					particle(p_muzzle,x+r*ex-a*ey,y+r*ey+a*ex)
					particlesize(0.1,0.1)
					particlecolor(32,204,255)
				elseif ((r/2)%2)==0 then
					particle(p_smoke,x+r*ex-a*ey,y+r*ey+a*ex)
				else
					particle(p_flare,x+r*ex-a*ey,y+r*ey+a*ex)
					particlecolor(128,255,255)
					particlesize(1,1)
				end
			end
			-- check if players are still alive
			if holzchopf.taser.target>0 then
				if getplayerhealth(holzchopf.taser.target)<=0 then
					holzchopf.taser.target=0
				end
			end
			-- or stop tasing when dist is too high
			if dist>152 then
				holzchopf.taser.target=0
			end
		-- electrify nothing
		else
			local a=math.rad(getplayerrotation(0)-17*getplayerdirection(0))
			local x=getplayerx(0)+6*getplayerdirection(0)+math.sin(a)*7
			local y=getplayery(0)+3-math.cos(a)*7
			if t<49 then
				for i=0,5 do
					particle(p_muzzle,x+math.random(-3,3),y+math.random(-3,3))
					particlesize(0.1,0.1)
					particlecolor(32,204,255)
				end
			else
				particle(p_smoke,x,y)
				particle(p_flare,x,y)
				particlecolor(128,255,255)
				particlesize(1,1)
			end
		end
	end
end